package engine;

/**
 * <p>This class stores the input values of the sample data set.</p>
 *
 * <p>ALTMMRFrame class is the listner for InputFrame class and
 * calls the addSubGroupData and sets all the input arrays.</p>
 */
public class EngineInput
{
    private double[] m_narray;
    private double[] m_sxarray;
    private double[] m_syarray;
    private double[] m_rxyarray;

    public String[] s_narray;
    public String[] s_sxarray;
    public String[] s_syarray;
    public String[] s_rxyarray;

    private int size = 0;
    private double m_alpha = 0;

    private int currentSize = 0;
    private int stringSize = 0;

    public EngineInput(int size)
    {
        this.size = size;
        m_narray = new double[size];
        m_sxarray = new double[size];
        m_syarray = new double[size];
        m_rxyarray = new double[size];

        s_narray = new String[size];
        s_sxarray = new String[size];
        s_syarray = new String[size];
        s_rxyarray = new String[size];
    }

    public void addSubGroupData(double mn, double msx, double msy, double mrxy)
    {
        m_narray[currentSize] = mn;
        m_sxarray[currentSize] = msx;
        m_syarray[currentSize] = msy;
        m_rxyarray[currentSize] = mrxy;

        currentSize++;
    }

     public void addSubGroupData(String mn, String msx, String msy, String mrxy)
    {
        s_narray[stringSize] = mn;
        s_sxarray[stringSize] = msx;
        s_syarray[stringSize] = msy;
        s_rxyarray[stringSize] = mrxy;

        stringSize++;
    }


    public double[] getMn()
    {
        return m_narray;
    }

    public double[] getMsx()
    {
        return this.m_sxarray;
    }

    public double[] getMsy()
    {
        return this.m_syarray;
    }

    public double[] getMrxy()
    {
        return this.m_rxyarray;
    }

    public int getSize()
    {
        return size;
    }

    public void setMAlpha(double m_alpha)
    {
        this.m_alpha = m_alpha;
    }

    public double getMAlpha()
    {
        return m_alpha;
    }

}
