package engine;
/**
 * <p>This class has static utility methods that are called by
 * Engine class.</p>
 */
public class MathUtil {

    public static double round(double d, int dec)
    {
      long l = power(10, dec);
      double x = .5 / l;
      x = (long)((d + x) * l);
      x = x / l;
      return x;
     }

    public static long power(int num, int factor)
    {
        if ( factor == 0 ) {
            return 1;
        }
        long l = num;
        while (--factor > 0) {
            l *= num;
        }
        return l;
    }

    public static double Chi(int k, double X)
    {
	    //calculate p value for this M and df on the chi-sqr distribution
	    //this algorithm was adapted from John Pezullo's JavaScript Code
		//available at http://members.aol.com/johnp71/pdfs.html
		double p, tt;
		int kk, aa;
		p = Math.exp(-.5*X);

        if((k-1)%2 ==1) {
            p = p*Math.sqrt(2*X/Math.PI);
        }
		kk = k-1;
		while(kk>=2) {
            p=p*X/kk; kk = kk-2;
        }
		tt=p;
		aa=k-1;
		while(tt>.000001*p) {
            aa=aa+2; tt=tt*X/aa; p=p+tt;
        }
		p=1-p;
		return p;
    }
}
